"use strict";
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
/* @internal */
class IntersperseAsyncIterable {
    constructor(xs, sep) {
        this.xs = xs;
        this.sep = sep;
    }
    [Symbol.asyncIterator]() {
        return intersperseAsync(this.xs, this.sep);
    }
}
exports.IntersperseAsyncIterable = IntersperseAsyncIterable;
/* @internal */
class IntercalateAsyncIterable {
    constructor(xs, sep) {
        this.xs = xs;
        this.sep = sep;
    }
    [Symbol.asyncIterator]() {
        return intercalateAsync(this.xs, this.sep);
    }
}
exports.IntercalateAsyncIterable = IntercalateAsyncIterable;
function intersperseAsync(it, sep) {
    return __asyncGenerator(this, arguments, function* intersperseAsync_1() {
        var e_1, _a;
        let first = true;
        try {
            for (var it_1 = __asyncValues(it), it_1_1; it_1_1 = yield __await(it_1.next()), !it_1_1.done;) {
                const x = it_1_1.value;
                if (!first) {
                    yield yield __await(sep);
                }
                yield yield __await(x);
                first = false;
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (it_1_1 && !it_1_1.done && (_a = it_1.return)) yield __await(_a.call(it_1));
            }
            finally { if (e_1) throw e_1.error; }
        }
    });
}
function intercalateAsync(it, sep) {
    return __asyncGenerator(this, arguments, function* intercalateAsync_1() {
        var e_2, _a;
        let first = true;
        try {
            for (var it_2 = __asyncValues(it), it_2_1; it_2_1 = yield __await(it_2.next()), !it_2_1.done;) {
                const x = it_2_1.value;
                if (!first) {
                    for (const y of sep) {
                        yield yield __await(y);
                    }
                }
                yield yield __await(x);
                first = false;
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (it_2_1 && !it_2_1.done && (_a = it_2.return)) yield __await(_a.call(it_2));
            }
            finally { if (e_2) throw e_2.error; }
        }
    });
}
